package com.company.fragmentaction.view.sampleentity;

import com.company.fragmentaction.entity.SampleEntity;
import com.company.fragmentaction.view.main.MainView;
import com.vaadin.flow.router.Route;
import io.jmix.flowui.Notifications;
import io.jmix.flowui.kit.action.ActionPerformedEvent;
import io.jmix.flowui.view.*;
import org.springframework.beans.factory.annotation.Autowired;


@Route(value = "sampleEntities", layout = MainView.class)
@ViewController("SampleEntity.list")
@ViewDescriptor("sample-entity-list-view.xml")
@LookupComponent("sampleEntitiesDataGrid")
@DialogMode(width = "64em")
public class SampleEntityListView extends StandardListView<SampleEntity> {

    @Autowired
    private Notifications notifications;

    @Subscribe("listViewAction")
    protected void onListViewAction(final ActionPerformedEvent event) {
        if (event.getComponent().getId().isPresent()) {
            String btnId = event.getComponent().getId().get();
            notifications.show("list view button pressed: ".concat(btnId));
        }
    }
}